SystemOrganization addCategory: #'Prolog-Core'!


Logic subclass: #Prolog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

Prolog subclass: #Doctor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

Prolog subclass: #Family
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

HierarchyBrowser subclass: #PrologBrowser
	instanceVariableNames: 'repl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

PackageInfo subclass: #PrologInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

Workspace subclass: #PrologWorkspace
	instanceVariableNames: 'doItReceiverPrototype'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

Prolog class
	instanceVariableNames: ''!

Doctor class
	instanceVariableNames: ''!

Family class
	instanceVariableNames: ''!

PrologBrowser class
	instanceVariableNames: ''!

PrologInfo class
	instanceVariableNames: ''!

PrologWorkspace class
	instanceVariableNames: ''!


!Doctor commentStamp: 'bolot 12/13/2002 15:59' prior: 0!
A demo class.

Used by Family>>health:

This class and other related classes in this category were originally written by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.
We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

!Family commentStamp: 'bolot 12/13/2002 15:24' prior: 0!
A demo class
Examples:
LCompiler evaluate: 'Family new :? father(x,y)'
LCompiler evaluate: 'Family new :? grandPa(''John'',y)'

This class and other related classes in this category were originally written by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.
We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

!Prolog commentStamp: 'bolot 12/13/2002 15:12' prior: 0!
This class and other related classes in this category were originally written by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.  We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

!PrologWorkspace commentStamp: 'bolot 12/13/2002 15:47' prior: 0!
PrologWorkspace

enables "pure" Prolog syntax to be used, instead of directly invoking LCompiler

try these:

Family new :? father(x,y)
Family new :? grandPa('John',y)
!

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/12/1999 19:22'!
acceptsLoggingOfCompilation
	^true! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/17/2008 10:32'!
addItemsToMenu: aMenu.

	aMenu addLine; 
		add: 'explore database' target: Prolog database selector: #explore.
	! !

!PrologInfo methodsFor: 'as yet unclassified' stamp: 'spfa 6/17/2008 21:51'!
additionalPackages
	"These are the names of packages that get loaded before the main change set"
	^#('Prolog-Documentation' 'Prolog-Dungeon' 'Prolog-Tests' 'REPLMorph' ) ! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:38'!
addLowerPanesTo: window at: nominalFractions with: editString

	| verticalOffset row innerFractions m |

	row := AlignmentMorph newColumn
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 1;
		borderColor: Color black;
		layoutPolicy: ProportionalLayout new.

	verticalOffset := 0.
	innerFractions := 0@0 corner: 1@0.
	verticalOffset := self addOptionalAnnotationsTo: row at: innerFractions plus: verticalOffset.
	verticalOffset := self addOptionalButtonsTo: row  at: innerFractions plus: verticalOffset.

	row 
		addMorph: ((m _ self buildMorphicCodePaneWith: editString) borderWidth: 0)
		fullFrame: (
			LayoutFrame 
				fractions: (innerFractions withBottom: 1) 
				offsets: (0@verticalOffset corner: 0@0)
		).
	window 
		addMorph: row
		frame: nominalFractions.

	row on: #mouseEnter send: #paneTransition: to: window.
	row on: #mouseLeave send: #paneTransition: to: window.

	m hasUnacceptedEdits: false! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:15'!
classListIndex: anInteger 

	super classListIndex: anInteger .
	self selectedClass ifNil: [^self].
	(self selectedClass == Prolog
		or: [self selectedClass inheritsFrom: Prolog])
		ifTrue: [repl evaluator: self selectedClass new]
	! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/7/1999 20:15'!
compilerClass
	^LCompiler! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'spfa 6/17/2008 21:57'!
decompilerClass
	"Answer a decompiler class appropriate for compiled methods of this class."

	^LDecompiler! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:49'!
demoString
	^
'Family example:

Family new :? father(x,y)
Family new :? grandPa(''John'',y)

Family new :? father(x, ''Mary'')
Family new :? father(''John'', ''Mary'')

Family new :? grandPa(''John'', x), father(y, x)

Family new :? health(''John'', y).
Family new :? consult( healthHistory(''John'', x), Doctor new)


GUI:

Family new openGui


Database:

Family new :? database(brother()). 
Family new :? assertz(brother(''John'', ''Stewart'')), asserta(brother(''John'', ''Barbara'')), assertz(brother(''John'', ''Alan'')).

Family new :? brother(x,y). 

Family new :? retract(brother(''John'', ''Stewart'')).

Family new :? brother(x,y).

Family new :? purgeDatabase(brother()).



Dungeon new :? go()


Resources:

Prolog Tutorial
http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/contents.html
'! !

!PrologWorkspace methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 15:46'!
doItReceiver
	^doItReceiverPrototype ifNil: [doItReceiverPrototype _ Prolog new]! !

!PrologWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 13:38'!
doItReceiver: aProlog
	doItReceiverPrototype _ aProlog! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/9/2008 14:50'!
evalString: aString

	^ LCompiler evaluate: 'self yourself :? ', aString for: self logged: false! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/17/2008 00:17'!
evalString: aString notifying: requestor

	^ LCompiler evaluate: 'self yourself :? ', aString for: self notifying: requestor logged: false! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'spfa 6/16/2008 23:37'!
evaluate: aString
	"Evaluating aString in the context of this class."

	^ LCompiler evaluate: 'self yourself :? ', aString for: self new logged: false! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 8/5/1999 16:21'!
evaluatorClass
	"Answer an evaluator class appropriate for evaluating expressions in the 
	context of this class."

	^LCompiler! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/17/2008 11:02'!
gui

	| window color browser hSepFrac repl |

	repl := REPLMorph on: self.
	browser := PrologBrowser new repl: repl; initHierarchyForClass: Prolog.
"	browser repl: repl."
	browser selectClass: self class.
	window := (SystemWindow labelled: browser labelString, ' & REPL' ) model: browser.

"	self addDependent: window."

	color := self guiColor.
	window setProperty: #paneColor toValue: color.

	hSepFrac := 0.3.

	Preferences scrollBarsOnRight ifFalse:
		[browser 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: self guiDocumentation].

	browser 
		addClassAndSwitchesTo: window 
		at: (0.0@0 corner: 0.33@hSepFrac)
		plus: 0.
	window 
		addMorph: browser buildMorphicMessageCatList
		frame: (0.33@0 extent: 0.33@hSepFrac).
	window addMorph: browser buildMorphicMessageList
		frame: (0.66@0 extent: 0.34@hSepFrac).

	Preferences scrollBarsOnRight ifTrue:
		[browser 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@0.6) 
			with: self guiDocumentation].

	window setUpdatablePanesFrom: #(classList messageCategoryList messageList).

	window addMorph: repl	frame: (0@0.6 corner: 1@1).

	^ window
! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/16/2008 13:13'!
guiColor

	^ Color blue muchLighter! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/17/2008 01:19'!
guiDocumentation

	^'"
Use the read-eval-print loop listener below to query the currently selected Prolog subclass.
Choose the ''decompile'' display option to inspect the actual Smalltalk code for logic predicates
(that''s the right-most button)

"'! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:43'!
initHierarchyForClass: aClassOrMetaClass
	| tab stab index nonMetaClass |
	centralClass := aClassOrMetaClass.
	nonMetaClass := aClassOrMetaClass theNonMetaClass.
	self systemOrganizer: SystemOrganization.
	metaClassIndicated := aClassOrMetaClass isMeta.
	classList := OrderedCollection new.
	tab := ''.
	nonMetaClass allSuperclasses reverseDo: 
		[:aClass | 
		(Prolog inheritsFrom: aClass)
			ifFalse: [
				classList add: tab , aClass name.
				tab := tab , '  ']].
	index := classList size + 1.
	nonMetaClass allSubclassesWithLevelDo:
		[:aClass :level |
		stab := ''.  1 to: level do: [:i | stab := stab , '  '].
		classList add: tab , stab , aClass name]
	 	startingLevel: 0.
	self classListIndex: index! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:33'!
labelString

	^ 'Prolog Browser'! !

!Prolog methodsFor: 'structures' stamp: 'spfa 6/17/2008 15:21'!
logicArg

arg(n, structure, x) :-
	is(list, (self allValue: structure)),
	is(len, list value size - 1),
	numlist(0,len,range),
	member(n, range),
	is(x, (list value at: n value +1)), !!.

arg(n, structure, x) :-
	integer(n),
	integer(x),
	is(x, structure at: n+1).! !

!Family methodsFor: 'demo' stamp: 'spfa 6/8/2008 21:27'!
logicFather

father('John', 'Mary').  "John is the father of Mary"
father('John', 'David').
father('David', 'Jack').
father('Arthur', 'Nancy').
! !

!Prolog methodsFor: 'structures' stamp: 'spfa 6/8/2008 21:28'!
logicFunctor

functor(structure, head, arguments) :-
	var(structure),
	atom(head),
	integer(arguments),
	is(structure, self
		structureHead: head
		arguments: arguments).
	"The first argument can be either a
	Relation or a List whose first
	element is a Symbol."
functor([sHead, sTail], head, arguments) :-
	atom(sHead),
	eq(head, sHead),
	is(arguments, sTail value size).! !

!Family methodsFor: 'demo' stamp: 'spfa 6/8/2008 23:03'!
logicGrandPa

"x is the grandPa of y."
grandPa(x, y) :-
	father(x, z),
	or(father(z, y),mother(z,y)).! !

!Family methodsFor: 'demo' stamp: 'spfa 6/8/2008 21:28'!
logicHealth

"Return the health history of x."
health(x, history) :-
	consult( healthHistory(x, history), Doctor new).! !

!Doctor methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:27'!
logicHealthHistory

healthHistory('John', 'John had two times of heart attacks').
healthHistory('Mary', 'Mary had no serious problems').! !

!Prolog methodsFor: 'basics' stamp: 'spfa 6/17/2008 14:35'!
logicMember

member(x,[x|_]).
member(x,[_|r]) :- member(x,r).! !

!Family methodsFor: 'demo' stamp: 'spfa 6/8/2008 21:28'!
logicMother

"Mary is the mother of Nancy."
mother('Mary', 'Nancy').! !

!Family methodsFor: 'demo' stamp: 'spfa 6/8/2008 23:03'!
logicParent

parent(x,y) :-
	or(father(x,y), mother(x,y)).! !

!Prolog methodsFor: 'structures' stamp: 'spfa 6/8/2008 21:28'!
logicUniv

univ(structure, list) :-
	nonvar(structure),
	is(true, structure value class == Relation),
	is(x, self allValue: structure),
	is(list, List
		head: x value head
		tail: x value tail).
univ(structure, [head, list]) :-
	atom(head),
	is(x, self allValue: list),
	is(structure, Relation
		head: head value
		tail: x value).! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 15:45'!
open
	self openLabel: 'Prolog Workspace'! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 09:04'!
openDemo
	"self openDemo"
	(self new contents: self demoString) openLabel: 'Prolog Workspace'! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/9/2008 14:55'!
openGui

	self gui openInWorld.! !

!PrologInfo methodsFor: 'as yet unclassified' stamp: 'spfa 6/17/2008 21:55'!
prerequisitePackages
	"These are the names of packages that get loaded before the main change set"
	^#('Prolog-Compiler' 'Prolog-Base') ! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/8/2008 21:28'!
primlogicAnd: assoc
    "Try to satisfy a list of goals."
    | aList |
    aList := assoc key.
    [aList isEmpty] whileFalse: [
        (self doOneGoal: aList head)
            ifTrue: [aList := aList tail]
            ifFalse: [^self]].
    ^assoc value! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/8/2008 21:29'!
primlogicAsserta: assoc
        "Add the fact in assoc to the
         beginning of the database."
    | arg aList |
    assoc key size = 1 ifFalse: [^self].
    arg := self allValue: (self first: assoc).
    aList := Database at: arg head ifAbsent: [^self].
    Database at: arg head put:
        (List head: arg tail tail: aList).
    ^assoc value! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/8/2008 21:29'!
primlogicAssertz: assoc
        "Add the fact in assoc to the
         end of the database."
    | arg aList |
    assoc key size = 1 ifFalse: [^self].
    arg := self allValue: (self first: assoc).
    aList := Database at: arg head ifAbsent: [^self].
    aList add: arg tail.
    ^assoc value! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/17/2008 10:28'!
primlogicAssert: assoc
        "Add the fact in assoc to the
         end of the database."
    ^ self primlogicAssertz: assoc! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/8/2008 21:29'!
primlogicAtomic: assoc
        "Succeed if the argument is a Symbol
         or an integer."
    | arg |
    assoc key size = 1 ifFalse: [^self].
    ((arg := self first: assoc) isSymbol
    or: [arg isKindOf: Integer])
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/8/2008 21:30'!
primlogicAtom: assoc
        "Succeed if the argument is a Symbol."
    assoc key size = 1 ifFalse: [^self].
    (self first: assoc) isSymbol
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/17/2008 12:14'!
primlogicCall: assoc
        "Execute the argument as a predicate."
    | blk |
    assoc key size = 1 ifFalse: [^self].
    blk := self first: assoc.
    ((blk isKindOf: List) and: [
    blk head isSymbol])
        ifFalse: [self error: 'not a goal'].
    ^[self perform: (Logic selectorForPredicate: blk head) 
            with: (Association key: blk tail
                value: assoc value)]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'spfa 6/8/2008 23:10'!
primlogicConsult: assoc
        "Ask the second argument as the receiver
         (a Smalltalk expression) to solve the goals
         contained in the first argument, e.g.
            consult(father(x, 'John'), family new)."
    | blk |
    assoc key size = 2 ifFalse: [^self].
    blk := self first: assoc.
    blk class == Relation
        ifFalse: [self error: 'first argument must be predicate'].
    ^[(self second: assoc) value
        perform: (Logic selectorForPredicate: blk head) 
        with: (Association key: blk tail
               value: assoc value)]! !

!Prolog methodsFor: 'backtracking' stamp: 'spfa 6/8/2008 21:30'!
primlogicCut: assoc 
	" Succeed always, exit the containing method
	  during backtacking."
	| blk mark |
	assoc key size = 1 ifFalse: [^ self].
	mark _ unboundVars size.
	blk _ assoc value.
	[(blk _ blk value) class == BlockContext] whileTrue.
	self unbindVar: mark.
	assoc key head value! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/16/2008 09:38'!
primlogicDatabase: assoc
        "Create a database which can hold facts
         being asserted or extracted. The argument
         must be a structure."
    | arg functor source |
    assoc key size = 1 ifFalse: [^self].
    arg := self first: assoc.
    ((arg isKindOf: Relation) and:
    [arg head isKindOf: Symbol])
        ifFalse: [self error: 'argument is not a fact'].
    functor := (arg head, ':') asSymbol.
    Database at: arg head ifAbsent: [
        Database at: arg head put: List new].
    ^assoc value! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/8/2008 21:30'!
primlogicEquiv: assoc
        "Succeed if the two arguments are the same object."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) == (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/8/2008 21:30'!
primlogicEq: assoc
        "Succeed if the two arguments can be unified."
    assoc key size = 2 ifFalse: [^self].
    self unify: assoc key head
        with: assoc key tail head
        then: [^assoc value]! !

!Prolog methodsFor: 'backtracking' stamp: 'spfa 6/8/2008 21:30'!
primlogicExit: assoc
	" exit Prolog "
	| blk |
	blk _ assoc value.
	[(blk _ blk value) class == BlockContext] whileTrue.
	^returnBlock value! !

!Prolog methodsFor: 'success-failure' stamp: 'spfa 6/8/2008 21:31'!
primlogicFail: assoc
        "Fail always."! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/8/2008 21:31'!
primlogicGe: assoc
        "Succeed if the first argument is
         greater than or equal to the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) >= (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/8/2008 21:31'!
primlogicGt: assoc
        "Succeed if the first argument is
         greater than the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) > (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'debugging' stamp: 'spfa 6/8/2008 21:31'!
primlogicHalt: assoc
        "Halt the execution.  Smalltalk debugger
         can be invoked at this point."
    assoc key size = 0 ifFalse: [^self].
    self halt! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/8/2008 21:30'!
primlogicInteger: assoc
        "Succeed if the argument is an Integer."
    assoc key size = 1 ifFalse: [^self].
    ((self first: assoc) isKindOf: Integer)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'spfa 6/8/2008 21:30'!
primlogicIs: assoc
        "Execute the second argument as a Smalltalk
         expression and then unify its result with
         the first argument."
    assoc key size = 2 ifFalse: [^self].
    self unify: assoc key head
        with: (self value: assoc key tail head) value
        then: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/8/2008 21:31'!
primlogicLe: assoc
        "Succeed if the first argument is
         less than or equal to the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) <= (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/8/2008 21:31'!
primlogicLt: assoc
        "Succeed if the first argument is
         less than the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) < (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/8/2008 21:31'!
primlogicNe: assoc
        "Succeed if the first argument is
         greater than the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) ~= (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'input-output' stamp: 'spfa 6/17/2008 11:04'!
primlogicNl: assoc
        "Write an end of line to
         Transcript."
    assoc key size = 0 ifFalse: [^self].
    self outputStream cr.
    ^assoc value! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/8/2008 21:30'!
primlogicNonvar: assoc
        "Succeed if the argument is not an
         unbound variable."
    assoc key size = 1 ifFalse: [^self].
    (self first: assoc) class == LogicUnbound
        ifFalse: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/8/2008 21:31'!
primlogicNotEquiv: assoc
        "Succeed if the two arguments
         are not the same object."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) == (self second: assoc)
        ifFalse: [^assoc value]! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/8/2008 22:19'!
primlogicNot: assoc
        "Succeed if the evaluation of the argument
         as a goal fails."
    | blk |
    assoc key size = 1 ifFalse: [^self].
    blk := self first: assoc.
    (blk isKindOf: List)
        ifFalse: [self error: 'argument must be goal'].
    blk :=
        self perform: (Logic selectorForPredicate: blk head) 
            with:
                (Association key: blk tail
                    value: [^self]).
    [blk class == BlockContext] "value until real success"
        whileTrue: [blk := blk value].
    ^assoc value! !

!Prolog methodsFor: 'basics' stamp: 'spfa 6/17/2008 14:30'!
primlogicNumlist: assoc
        "Unify the third argument with a list of integer 
		within a range defined by the first arguments."
    assoc key size = 3 ifFalse: [^self].
    self unify: assoc key tail tail head 
		with: ((self first: assoc) to: (self second: assoc)) asList 
        	then: [^assoc value]

! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/8/2008 21:29'!
primlogicOr: assoc
    "Disjunction predicate."
    assoc key size = 2 ifFalse: [^self].
    self doGoal: (self first: assoc) continue: assoc value.
    self doGoal: (self second: assoc) continue: assoc value! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/8/2008 21:29'!
primlogicPurgeDatabase: assoc
        "Purge a database identified by the
         structure in the argument."
    | arg |
    assoc key size = 1 ifFalse: [^self].
    arg := self first: assoc.
    ((arg isKindOf: Relation) and:
    [arg head isSymbol])
        ifFalse: [self error: 'argument is not a fact'].
    Database at: arg head ifAbsent: [^self].
    Database removeKey: arg head.
    ^assoc value! !

!Prolog methodsFor: 'input-output' stamp: 'spfa 6/17/2008 11:44'!
primlogicReadstring: assoc
        "Read a string and answer the result."
    | anAnswer |
    assoc key size = 1 ifFalse: [^self].
    anAnswer := FillInTheBlank
		request: 'type a line and accept'
		initialAnswer: ''.
    self unify: assoc key head
        with: anAnswer
        then: [^assoc value]! !

!Prolog methodsFor: 'input-output' stamp: 'spfa 6/17/2008 11:44'!
primlogicRead: assoc
        "Read a Smalltalk expression, evaluate it and
         answer the result.  This can be used to input
         a Symbol, a number, a quoted string, etc."
    | anAnswer |
    assoc key size = 1 ifFalse: [^self].
    anAnswer := Compiler evaluate: (FillInTheBlank
		request: 'type a Smalltalk expression and accept'
		initialAnswer: '').
    self unify: assoc key head
        with: anAnswer
        then: [^assoc value]! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/8/2008 21:29'!
primlogicRepeat: assoc
        "Succeed always, even
         during backtacking."
    | blk mark |
    assoc key size = 0 ifFalse: [^self].
    mark := unboundVars size.
    [true] whileTrue: [
        blk := assoc value.
        [(blk := blk value) class == BlockContext]
            whileTrue: [].
        self unbindVar: mark]! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/8/2008 21:29'!
primlogicRetract: assoc
        "Delete the first fact unified with the
         one in assoc from the database. Delete
         the next one during backtrack."
    | arg aList bList |
    assoc key size = 1 ifFalse: [^self].
    arg := self first: assoc.
    [aList := Database at: arg head ifAbsent: [^self].
     aList isEmpty ifTrue: [^self].
     self unify: arg tail
        with: aList head
        then: [Database at: arg head put: aList tail.
               assoc value value].
     aList == (Database at: arg head)]
        whileFalse: [].
    [(bList := aList tail) isEmpty] whileFalse: [
        self unify: arg tail
            with: aList tail head
            then: [aList tail: aList tail tail.
                   bList := aList.
                   assoc value value].
        aList := bList.
        aList isEmpty ifTrue: [^self]]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'spfa 6/8/2008 21:30'!
primlogicRuntime: assoc
        "Unify the first argument with
         the system time in milliseconds."
    assoc key size = 1 ifFalse: [^self].
    self unify: assoc key head
        with: Time millisecondClockValue
        then: [^assoc value]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'spfa 6/17/2008 17:42'!
primlogicSend: assoc

    assoc key size = 3 ifTrue: [
    	self unify: assoc key tail tail head 
			with: ((self first: assoc) perform: (self second: assoc)) 
        	then: [^assoc value].
	^self].

    assoc key size = 4 ifFalse: [^self].
    self unify: assoc key tail tail tail head 
		with: ((self first: assoc) perform: (self second: assoc) 
			withArguments: (self third: assoc) asArray)  
        	then: [^assoc value]

! !

!Prolog methodsFor: 'success-failure' stamp: 'spfa 6/8/2008 21:31'!
primlogicTrue: assoc
        "Succeed always."
    assoc key size = 0 ifFalse: [^self].
    ^assoc value! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/8/2008 21:30'!
primlogicVar: assoc
        "Succeed if the argument is an
         unbound variable."
    assoc key size = 1 ifFalse: [^self].
    (self first: assoc) class == LogicUnbound
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'input-output' stamp: 'spfa 6/17/2008 11:03'!
primlogicWrite: assoc
        "Write all the arguments to Transcript."
    | value |
    assoc key do: [:argument |
        value := self allValue: argument.
        self outputStream nextPutAll:
            ((value isKindOf: String)
                ifTrue: [value]
                ifFalse: [value printString])].
    ^assoc value! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/16/2008 15:03'!
prompt

	^ self class asString, ' ?-'! !

!PrologInfo methodsFor: 'as yet unclassified' stamp: 'spfa 6/17/2008 22:19'!
readmeText
	"Text shown to the user after load"
	| s |
	s := String new writeStream.
	s nextPutAll: '
This is Prolog for Squeak, initially adapted by Bolot Kerimbaev from Prolog/V by Mike Teng,
now being refactored by Stephane Rollandin for Squeak 3.8 and newer.

For old-style Prolog workspace:
	PrologWorkspace openDemo.   "doIt"

For newer integrated browser & REPL:
	Family new openGui.		"doIt"
	Chapter2 new openGui.		"doIt"

The original paper from Mike Teng should be available at
	http://www.zogotounga.net/comp/squeak/v-prolog.pdf
...note that this is somewhat deprecated.

Dungeon demo:
	Dungeon ? ''go()''		"doIt"



produced from package ';
		nextPutAll: self packageName;
		nextPutAll: ' on ';
		nextPutAll: Date today printString;
		space;
		nextPutAll: Time now printString;
		cr.
	^s contents.! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:06'!
repl: aREPLMorph

	repl _ aREPLMorph! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'spfa 6/8/2008 21:20'!
sourceCodeTemplate
	"Answer an expression to be edited and evaluated in order to define 
	methods in this class."

    ^ Logic prologKeyword, 'Predicate
"comment"
predicate(term1, term2) :-
    goal1(term3),
    goal2(term4).'! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/12/1999 19:22'!
wantsChangeSetLogging
	^true! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'spfa 6/16/2008 23:49'!
? aString
	"Evaluating aString in the context of this class."

	^ self evaluate: aString! !
